//+------------------------------------------------------------------+
//|                                          Awesome SignalAlert.mq4 |
//|                               mod. version of Awesome_Signal.mq4 |
//|                 Copyright  2005, Kalenzo, contact@fxservice.eu  |
//|                                         http://www.fxservice.eu/ |
//|                   Alerts mod. fxdaytrader, http://ForexBaron.net |
//+------------------------------------------------------------------+
//////////////////////////////////////////////////////////////////////
// !!! YOU MUST COMPILE THIS EA WITH THE BUILD 509 COMPILER, download the metaeditor for build 509 at http://www.forexfactory.com/showthread.php?t=470340 !!!
//////////////////////////////////////////////////////////////////////
#property  copyright "Kalenzo contact@fxservice.eu // mod. fxdaytrader, http://ForexBaron.net"
#property  link      "http://www.fxservice.eu/"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 4
#property  indicator_color1  Black
#property  indicator_color2  Green
#property  indicator_color3  Red
#property  indicator_color4  Gold
#property  indicator_level1 0.0 //fxdaytrader, also made more parameters external

extern int FastMaPeriod = 5;
extern int FastMaShift  = 0;
extern ENUM_MA_METHOD FastMaMode   = MODE_SMA;
extern ENUM_APPLIED_PRICE FastMaPrice  = PRICE_MEDIAN;

extern int SlowMaPeriod = 34;
extern int SlowMaShift  = 0;
extern ENUM_MA_METHOD SlowMaMode   = MODE_SMA;
extern ENUM_APPLIED_PRICE SlowMaPrice  = PRICE_MEDIAN;

extern int SignalPeriod =5;
extern int SignalShift  = 0;
extern ENUM_MA_METHOD SignalMode   = MODE_SMA;

extern string ahi0=" ******* Alert settings:";
extern bool EnableSignalLineAlert = true;
extern bool EnableZeroLineCrossoverAlert = true;
extern string ahi1 = " *** Alert methods:";
extern bool PopupAlerts            = TRUE;
extern bool EmailAlerts            = FALSE;
extern bool PushNotificationAlerts = FALSE;
extern bool SoundAlerts            = FALSE;
extern string SoundFileLong        = "alert.wav";
extern string SoundFileShort       = "alert2.wav";


//---- indicator buffers
double     ExtBuffer0[];
double     ExtBuffer1[];
double     ExtBuffer2[];
double     SignalBuffer[];
int a=0,b=0,c=0,d=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   //---- drawing settings
   SetIndexStyle(0,DRAW_NONE);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexStyle(3,DRAW_LINE,STYLE_SOLID);
    SetIndexShift( 3, SignalShift); 
   
   IndicatorDigits(Digits+1);
   SetIndexDrawBegin(0,34);
   SetIndexDrawBegin(1,34);
   SetIndexDrawBegin(2,34);
   SetIndexDrawBegin(3,34);
   
//---- 3 indicator buffers mapping
   SetIndexBuffer(0,ExtBuffer0);
   SetIndexBuffer(1,ExtBuffer1);
   SetIndexBuffer(2,ExtBuffer2);
   SetIndexBuffer(3,SignalBuffer);
//---- name for DataWindow and indicator subwindow label
   /*
   IndicatorShortName("AO");
   SetIndexLabel(1,NULL);
   SetIndexLabel(2,NULL);
   */
   //fxdaytrader:
   IndicatorShortName("AO SignalAlert");
   SetIndexLabel(1,"UP");
   SetIndexLabel(2,"DOWN");
   SetIndexLabel(3,"SignalMa");
   //end fxdaytrader
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Awesome Oscillator                                               |
//+------------------------------------------------------------------+
int start()
  {
   int    limit;
   int    counted_bars=IndicatorCounted();
   double prev,current;
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- macd
   for(int i=0; i<limit; i++)
      ExtBuffer0[i]=iMA(NULL,0,FastMaPeriod,FastMaShift,FastMaMode,FastMaPrice,i)-iMA(NULL,0,SlowMaPeriod,SlowMaShift,SlowMaMode,SlowMaPrice,i);
//---- dispatch values between 2 buffers
   bool up=true;
   for(i=limit-1; i>=0; i--)
     {
      current=ExtBuffer0[i];
      prev=ExtBuffer0[i+1];
      if(current>prev) up=true;
      if(current<prev) up=false;
      if(!up)
        {
         ExtBuffer2[i]=current;
         ExtBuffer1[i]=0.0;
        }
      else
        {
         ExtBuffer1[i]=current;
         ExtBuffer2[i]=0.0;
        }
     }
// ----- Draw signal
    for(i=0; i<limit; i++)
         SignalBuffer[i]=iMAOnArray(ExtBuffer0,Bars,SignalPeriod,SignalShift,SignalMode,i);
        
         
    if(EnableSignalLineAlert)
    {
       if(ExtBuffer0[0]<SignalBuffer[0] && ExtBuffer0[1]>=SignalBuffer[1] && Bars>a)
       {
         //Alert(Symbol()+" Period "+Period()+" AO CROSSED Signal (SELL)");
         doAlerts("AO cross signal: SELL",SoundFileShort);//fxdaytrader
         a = Bars;
       }
       
       if(ExtBuffer0[0]>SignalBuffer[0] && ExtBuffer0[1]<=SignalBuffer[1] && Bars>b)
       {
         //Alert(Symbol()+" Period "+Period()+" AO CROSSED Signal (BUY)");
         doAlerts("AO cross signal: BUY",SoundFileLong);//fxdaytrader
         b = Bars;
       } 
    }     
    
    if(EnableZeroLineCrossoverAlert)
    {
       if(ExtBuffer0[0]<0 && ExtBuffer0[1]>=0 && Bars>c)
       {
         //Alert(Symbol()+" Period "+Period()+" AO CROSSED ZERO LINE (SELL)");
         doAlerts("AO zero line cross signal: SELL",SoundFileShort);//fxdaytrader
         c = Bars;
       }
       
       if(ExtBuffer0[0]>0 && ExtBuffer0[1]<=0 && Bars>d)
       {
         //Alert(Symbol()+" Period "+Period()+" AO CROSSED ZERO LINE (BUY)");
         doAlerts("AO zero line cross signal: BUY",SoundFileLong);//fxdaytrader
         d = Bars;
       }
    }
         
//---- done
   return(0);
  }
//+------------------------------------------------------------------+
//fxdaytrader:
void doAlerts(string msg,string SoundFile) {
        msg="Awesome SignalAlert on "+Symbol()+", period "+TFtoStr(Period())+": "+msg+", bid = "+DoubleToStr(MarketInfo(Symbol(),MODE_BID),Digits)+", servertime: "+TimeToStr(TimeCurrent());
 string emailsubject="MT4 alert on acc. "+AccountNumber()+", "+WindowExpertName()+" - Alert on "+Symbol()+", period "+TFtoStr(Period());
  if (PopupAlerts) Alert(msg);
  if (EmailAlerts) SendMail(emailsubject,msg);
  if (PushNotificationAlerts) SendNotification(msg);
  if (SoundAlerts) PlaySound(SoundFile);
}//void doAlerts(string msg,string SoundFile) {

string TFtoStr(int period) {
 if (period==0) period=Period();
 switch(period) {
  case 1     : return("M1");  break;
  case 5     : return("M5");  break;
  case 15    : return("M15"); break;
  case 30    : return("M30"); break;
  case 60    : return("H1");  break;
  case 240   : return("H4");  break;
  case 1440  : return("D1");  break;
  case 10080 : return("W1");  break;
  case 43200 : return("MN1"); break;
  default    : return(DoubleToStr(period,0));
 }
 return("UNKNOWN");
}//string TFtoStr(int period) {

